Package ru.bitel.bgbilling.kernel.contract.api.common.service

# Interface ContractService

public interface ContractService

- ## Method Summary

  Modifier and Type
  Method
  Description
  `List<ru.bitel.bgbilling.common.model.ConfigParameter>`
  `configParameterList(String className)`
  `Contract`
  `contractByTitle(String contractTitle)`
  `List<ContractCard>`
  `contractCardList(int contractId)`
  список карточек договора для указанного договра
  `org.json.JSONObject`
  `contractCommentPatternList(int contractId)`
  `String`
  `contractCommentPatternValue(int contractId, int patternId)`
  `int`
  `contractCreate(ContractCreateData contractCreateData)`
  `void`
  `contractCreateValidateParameters(ContractCreateData contractCreateData)`
  `void`
  `contractCreateValidateTariffs(ContractCreateData contractCreateData)`
  `void`
  `contractDateToUpdate(int contractId, Date dateTo)`
  `void`
  `contractDelete(int contractId, boolean save, String folder)`
  Удаление договора
  `void`
  `contractDomainUpdate(int contractId, int domainId)`
  Обновление домена договора
  `void`
  `contractFaceUpdate(int contractId, ContractFace contractFace)`
  `Contract`
  `contractGet(int contractId)`
  `void`
  `contractGroupAdd(int contractId, int contractGroupId)`
  `void`
  `contractGroupRemove(int contractId, int contractGroupId)`
  `org.json.JSONObject`
  `contractInfoGet(int contractId)`
  Информация о договоре
  `SearchResult<ru.bitel.bgbilling.kernel.contract.api.common.dto.ContractSearchDto>`
  `contractList(int contractId, String title, String comment, int fc, long groupMask, List<FilterEntityAttr> entityFilter, boolean subContracts, boolean closed, boolean hidden, Page page)`
  `String`
  `contractListByFilter(ContractFilters contractFilters, List<FilterEntityAttr> entityFilter, jakarta.xml.ws.Holder<Page> page)`
  `void`
  `contractModeUpdate(int contractId, ContractMode contractMode)`
  `void`
  `contractModuleAdd(int contractId, List<Integer> moduleIds)`
  `String`
  `contractModuleConfigGet(int contractId, int moduleId, String key)`
  `void`
  `contractModuleConfigSet(int contractId, int moduleId, String key, String value)`
  Установка параметра конфига модуля для договора.
  `void`
  `contractModuleDelete(int contractId, List<Integer> moduleIds)`
  `void`
  `contractParameterAddressUpdate(int contractId, EntityAttrAddress parameter)`
  `void`
  `contractParameterBooleanUpdate(int contractId, EntityAttrBoolean parameter)`
  `void`
  `contractParameterContractUpdate(int contractId, EntityAttrContract parameter)`
  `void`
  `contractParameterDateUpdate(int contractId, EntityAttrDate parameter)`
  `void`
  `contractParameterEmailUpdate(int contractId, EntityAttrEmail parameter)`
  `EntityAttr`
  `contractParameterGet(int contractId, int parameterId)`
  Получение параметра договора.
  `ContractParameterGroup`
  `contractParameterGroupGet(int id)`
  Deprecated.
  use `ContractParameterService.contractParameterGroupGet(int)`
  `List<ContractParameterGroup>`
  `contractParameterGroupList()`
  Deprecated.
  use `ContractParameterService.contractParameterGroupList()`
  `void`
  `contractParameterGroupSet(int contractId, int paramGroupId)`
  `List<ContractParameterHistoryData>`
  `contractParameterHistoryList(int contractId, int parameterId, int parameterType)`
  `void`
  `contractParameterIntUpdate(int contractId, EntityAttrInt parameter)`
  `List<IdTitleValue>`
  `contractParameterList(int contractId)`
  Параметры договора
  `void`
  `contractParameterListUpdate(int contractId, EntityAttrList parameter)`
  `MapHolder<Integer,EntityAttr>`
  `contractParameterMap(int contractId, int paramGroupId)`
  Map параметров договора.
  Если параметр не заведен (не указан, не добавлен), то данный параметр будет отсутствовать в результате.
  `MapHolder<Integer,EntityAttr>`
  `contractParameterMapByType(int contractId, int parameterType)`
  `void`
  `contractParameterMultiListUpdate(int contractId, EntityAttrMultiList parameter)`
  `void`
  `contractParameterPhoneUpdate(int contractId, EntityAttrPhone parameter)`
  `void`
  `contractParametersCopy(int fromContractId, int toContractId, Set<Integer> parameterIds, String mode)`
  `void`
  `contractParameterTextUpdate(int contractId, EntityAttrText parameter)`
  `void`
  `contractParameterUpdate(int contractId, EntityAttr parameter)`
  Добавление/обновление/удаление параметра договора.
  `SearchResult<ContractPasswordLogItem>`
  `contractPasswordLogs(int contractId, String[] sort, Page page)`
  `int`
  `contractPasswordOnceCheck(String passwordOnce)`
  Вход по единоразовому паролю, сгенерированному при вызове contractPasswordReset
  `void`
  `contractPasswordReset(int contractId, String email)`
  Сброс пароля с отправкой нового на email.
  `void`
  `contractPasswordUpdate(int contractId, String password, boolean generate)`
  Установка нового пароля для ЛК договора.
  `void`
  `contractPatternDelete(int id)`
  `ContractPattern`
  `contractPatternGet(int id)`
  `void`
  `contractsDomainUpdate(List<Integer> contractIds, int domainId)`
  Обновление домена договоров
  `List<Contract>`
  `contractSubList(int contractId, int subMode, boolean withSuperCid, Date onDate)`
  Получение списка субдоговоров.
  `org.json.JSONObject`
  `contractTitleAndCommentGet(int contractId)`
  `void`
  `contractTitleAndCommentUpdate(int contractId, String title, String comment, int patternId)`
  `void`
  `contractUpdate(int contractId, Contract contract)`
  Обновление уже существующего договора в БД.
  `boolean`
  `hasModuleInstance(int contractId, int moduleId)`
  Проверка на наличие привязки указанного модуля к договору.
  `SearchResult<ru.bitel.bgbilling.kernel.contract.api.common.dto.ContractSearchDto>`
  `searchContractByObjectParameter(ContractSearchParam contractSearchParam)`
  `SearchResult<ru.bitel.bgbilling.kernel.contract.api.common.dto.ContractSearchDto>`
  `searchContractByParameter(ContractSearchParam contractSearchParam)`
  `SearchResult<ru.bitel.bgbilling.kernel.contract.search.common.ContractHistoryRecord>`
  `searchContractHistoryRecord(Page page)`
  `SearchResult<ru.bitel.bgbilling.kernel.contract.api.common.dto.ContractSearchDto>`
  `searchContractList(ContractSearchParam contractSearchParam)`
  `void`
  `sendWebPasswordOfContractToEmail(String email, int contractId)`
  Отправка пароля статистики на почту
  `void`
  `updateContractHistoryRecord(int contractId)`

- ## Method Details

  - ### contractGet

    Contract contractGet(int contractId) throws Exception
    Parameters:
      `contractId` - - код договора.
    Returns:
      - договор или null, если договор отсутствует.
    Throws:
      `Exception`

  - ### contractByTitle

    Contract contractByTitle(String contractTitle) throws Exception
    Throws:
      `Exception`

  - ### contractUpdate

    void contractUpdate(int contractId, Contract contract) throws Exception
    Обновление уже существующего договора в БД.
    Parameters:
      `contractId` - ID договора.
      `contract` - договор.
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `Exception`

  - ### contractGroupAdd

    void contractGroupAdd(int contractId, int contractGroupId) throws Exception
    Throws:
      `Exception`

  - ### contractGroupRemove

    void contractGroupRemove(int contractId, int contractGroupId) throws Exception
    Throws:
      `Exception`

  - ### contractSubList

    List<Contract> contractSubList(int contractId, int subMode, boolean withSuperCid, Date onDate) throws Exception
    Получение списка субдоговоров.
    Parameters:
      `contractId` - - код договора.
      `subMode` - - зависимый, независимый режим из KernelConst. Если subMode == -1, вернет все субдоговора.
      `withSuperCid` - - если == true, то в список добавится и супер договор в начало списка.
      `onDate` - если не null, отфильтровать договора активные по периоду на указанную дату
    Throws:
      `Exception`

  - ### searchContractByParameter

    SearchResult<ru.bitel.bgbilling.kernel.contract.api.common.dto.ContractSearchDto> searchContractByParameter(ContractSearchParam contractSearchParam) throws Exception
    Throws:
      `Exception`

  - ### searchContractByObjectParameter

    SearchResult<ru.bitel.bgbilling.kernel.contract.api.common.dto.ContractSearchDto> searchContractByObjectParameter(ContractSearchParam contractSearchParam) throws Exception
    Throws:
      `Exception`

  - ### searchContractList

    SearchResult<ru.bitel.bgbilling.kernel.contract.api.common.dto.ContractSearchDto> searchContractList(ContractSearchParam contractSearchParam) throws Exception
    Throws:
      `Exception`

  - ### contractList

    SearchResult<ru.bitel.bgbilling.kernel.contract.api.common.dto.ContractSearchDto> contractList(int contractId, String title, String comment, int fc, long groupMask, List<FilterEntityAttr> entityFilter, boolean subContracts, boolean closed, boolean hidden, Page page) throws Exception
    Throws:
      `Exception`

  - ### contractListByFilter

    String contractListByFilter(ContractFilters contractFilters, List<FilterEntityAttr> entityFilter, jakarta.xml.ws.Holder<Page> page) throws Exception
    Throws:
      `Exception`

  - ### hasModuleInstance

    boolean hasModuleInstance(int contractId, int moduleId) throws Exception
    Проверка на наличие привязки указанного модуля к договору.
    Parameters:
      `contractId` - код договора
      `moduleId` - код модуля
    Returns:
      true если экземпляр модуля привязан к договору, false - в противном случае.
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `Exception`

  - ### contractPasswordReset

    void contractPasswordReset(int contractId, String email) throws Exception
    Сброс пароля с отправкой нового на email.
    Parameters:
      `contractId` -
      `email` - если указан, то происходит проверка что он совпадает с тем, что указан в договоре - иначе просто отправляет на тот что в договоре.
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `Exception`

  - ### contractPasswordOnceCheck

    int contractPasswordOnceCheck(String passwordOnce) throws Exception
    Вход по единоразовому паролю, сгенерированному при вызове contractPasswordReset
    Parameters:
      `passwordOnce` - единоразовый пароль
    Returns:
      ID договора или 0, если пароль не найден
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `Exception`

  - ### contractParametersCopy

    void contractParametersCopy(int fromContractId, int toContractId, Set<Integer> parameterIds, String mode) throws Exception
    Throws:
      `Exception`

  - ### contractParameterMap

    MapHolder<Integer,EntityAttr> contractParameterMap(int contractId, int paramGroupId) throws Exception
    Map параметров договора.
    Если параметр не заведен (не указан, не добавлен), то данный параметр будет отсутствовать в результате. Примером может служить параметр типа флаг - отсутствие параметра означает false.
    Parameters:
      `contractId` - ID договора.
      `paramGroupId` - ID группы параметров договора `ContractParameterGroup`. Если значение >0, то выдаются параметры указанной группы, иначе - все параметры.
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `Exception`

  - ### contractParameterList

    List<IdTitleValue> contractParameterList(int contractId) throws Exception
    Параметры договора
    Parameters:
      `contractId` -
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `ru.bitel.bgbilling.common.BGMessageException`
      `Exception`

  - ### contractParameterGroupSet

    void contractParameterGroupSet(int contractId, int paramGroupId) throws Exception
    Throws:
      `Exception`

  - ### contractParameterGroupGet

    @Deprecated ContractParameterGroup contractParameterGroupGet(int id) throws Exception
    Deprecated.
    use `ContractParameterService.contractParameterGroupGet(int)`
    Получение группы параметров договора по ID.
    Parameters:
      `id` - ID группы параметров.
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `Exception`

  - ### contractParameterGroupList

    @Deprecated List<ContractParameterGroup> contractParameterGroupList() throws Exception
    Deprecated.
    use `ContractParameterService.contractParameterGroupList()`
    Получение списка групп параметров договора.
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `Exception`
    See Also:
      - `ContractParameterGroup`

  - ### searchContractHistoryRecord

    SearchResult<ru.bitel.bgbilling.kernel.contract.search.common.ContractHistoryRecord> searchContractHistoryRecord(Page page) throws Exception
    Throws:
      `Exception`

  - ### updateContractHistoryRecord

    void updateContractHistoryRecord(int contractId) throws Exception
    Throws:
      `Exception`

  - ### contractModuleConfigGet

    String contractModuleConfigGet(int contractId, int moduleId, String key) throws Exception
    Throws:
      `Exception`

  - ### contractModuleConfigSet

    void contractModuleConfigSet(int contractId, int moduleId, String key, String value) throws Exception
    Установка параметра конфига модуля для договора.
    Parameters:
      `contractId` - ID договора.
      `moduleId` - ID модуля.
      `key` - ключ.
      `value` - значение.
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `Exception`

  - ### contractDomainUpdate

    void contractDomainUpdate(int contractId, int domainId) throws Exception
    Обновление домена договора
    Parameters:
      `contractId` - ID договора.
      `domainId` - ID домена.
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `Exception`
    See Also:
      - `Domain`

  - ### contractsDomainUpdate

    void contractsDomainUpdate(List<Integer> contractIds, int domainId)
    Обновление домена договоров
    Parameters:
      `contractIds` - ID договоров.
      `domainId` - ID домена.
    See Also:
      - `Domain`

  - ### contractParameterUpdate

    void contractParameterUpdate(int contractId, EntityAttr parameter) throws Exception
    Добавление/обновление/удаление параметра договора. Удаление происходит в случае, если entityAttr null или значение внутри entityAttr пустое.
    Parameters:
      `contractId` - ID договора.
      `parameter` - параметр.
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `Exception`
    See Also:
      - `EntityAttr`
      - `EntityAttrText`

  - ### contractParameterTextUpdate

    void contractParameterTextUpdate(int contractId, EntityAttrText parameter) throws Exception
    Throws:
      `Exception`

  - ### contractParameterDateUpdate

    void contractParameterDateUpdate(int contractId, EntityAttrDate parameter) throws Exception
    Throws:
      `Exception`

  - ### contractParameterBooleanUpdate

    void contractParameterBooleanUpdate(int contractId, EntityAttrBoolean parameter) throws Exception
    Throws:
      `Exception`

  - ### contractParameterPhoneUpdate

    void contractParameterPhoneUpdate(int contractId, EntityAttrPhone parameter) throws Exception
    Throws:
      `Exception`

  - ### contractParameterListUpdate

    void contractParameterListUpdate(int contractId, EntityAttrList parameter) throws Exception
    Throws:
      `Exception`

  - ### contractParameterIntUpdate

    void contractParameterIntUpdate(int contractId, EntityAttrInt parameter) throws Exception
    Throws:
      `Exception`

  - ### contractParameterAddressUpdate

    void contractParameterAddressUpdate(int contractId, EntityAttrAddress parameter) throws Exception
    Throws:
      `Exception`

  - ### contractParameterEmailUpdate

    void contractParameterEmailUpdate(int contractId, EntityAttrEmail parameter) throws Exception
    Throws:
      `Exception`

  - ### contractParameterContractUpdate

    void contractParameterContractUpdate(int contractId, EntityAttrContract parameter) throws Exception
    Throws:
      `Exception`

  - ### contractParameterMultiListUpdate

    void contractParameterMultiListUpdate(int contractId, EntityAttrMultiList parameter) throws Exception
    Throws:
      `Exception`

  - ### contractParameterGet

    EntityAttr contractParameterGet(int contractId, int parameterId) throws Exception
    Получение параметра договора.
    Parameters:
      `contractId` - ID договора
      `parameterId` - ID параметра
    Returns:
    Throws:
      `Exception`

  - ### contractParameterMapByType

    MapHolder<Integer,EntityAttr> contractParameterMapByType(int contractId, int parameterType) throws Exception
    Throws:
      `Exception`

  - ### sendWebPasswordOfContractToEmail

    void sendWebPasswordOfContractToEmail(String email, int contractId) throws Exception
    Отправка пароля статистики на почту
    Parameters:
      `email` - адрес или несколько адресов, куда будет отправлен пароль
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `Exception`

  - ### contractDelete

    void contractDelete(int contractId, boolean save, String folder) throws Exception
    Удаление договора
    Parameters:
      `contractId` - id удаляемого договора
      `save` - нужно ли сохранять удаляемый договор на диск
      `folder` - путь до директории для сохранения копии удаляемого договора
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `Exception`

  - ### contractInfoGet

    org.json.JSONObject contractInfoGet(int contractId) throws Exception
    Информация о договоре
    Parameters:
      `contractId` -
    Returns:
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `Exception`

  - ### contractTitleAndCommentGet

    org.json.JSONObject contractTitleAndCommentGet(int contractId) throws Exception
    Throws:
      `Exception`

  - ### contractCommentPatternList

    org.json.JSONObject contractCommentPatternList(int contractId) throws Exception
    Throws:
      `Exception`

  - ### contractTitleAndCommentUpdate

    void contractTitleAndCommentUpdate(int contractId, String title, String comment, int patternId) throws Exception
    Throws:
      `Exception`

  - ### contractCommentPatternValue

    String contractCommentPatternValue(int contractId, int patternId) throws Exception
    Throws:
      `Exception`

  - ### contractCardList

    List<ContractCard> contractCardList(int contractId) throws Exception
    список карточек договора для указанного договра
    Throws:
      `Exception`

  - ### configParameterList

    List<ru.bitel.bgbilling.common.model.ConfigParameter> configParameterList(String className) throws Exception
    Throws:
      `Exception`

  - ### contractPatternGet

    ContractPattern contractPatternGet(int id) throws Exception
    Throws:
      `Exception`

  - ### contractPatternDelete

    void contractPatternDelete(int id) throws Exception
    Throws:
      `Exception`

  - ### contractParameterHistoryList

    List<ContractParameterHistoryData> contractParameterHistoryList(int contractId, int parameterId, int parameterType) throws Exception
    Throws:
      `Exception`

  - ### contractCreate

    int contractCreate(ContractCreateData contractCreateData) throws Exception
    Throws:
      `Exception`

  - ### contractCreateValidateParameters

    void contractCreateValidateParameters(ContractCreateData contractCreateData) throws Exception
    Throws:
      `Exception`

  - ### contractCreateValidateTariffs

    void contractCreateValidateTariffs(ContractCreateData contractCreateData) throws Exception
    Throws:
      `Exception`

  - ### contractModuleAdd

    void contractModuleAdd(int contractId, List<Integer> moduleIds) throws Exception
    Throws:
      `Exception`

  - ### contractModuleDelete

    void contractModuleDelete(int contractId, List<Integer> moduleIds) throws Exception
    Throws:
      `Exception`

  - ### contractDateToUpdate

    void contractDateToUpdate(int contractId, Date dateTo) throws Exception
    Throws:
      `Exception`

  - ### contractPasswordLogs

    SearchResult<ContractPasswordLogItem> contractPasswordLogs(int contractId, String[] sort, Page page) throws Exception
    Throws:
      `Exception`

  - ### contractPasswordUpdate

    void contractPasswordUpdate(int contractId, String password, boolean generate) throws Exception
    Установка нового пароля для ЛК договора.
    Parameters:
      `contractId` - ID договора.
      `password` - пароль.
      `generate` - нужно ли сгенерировать автоматически, если true - то значение аргумента password игнорируется.
    Throws:
      `ru.bitel.bgbilling.common.BGException`
      `Exception`

  - ### contractModeUpdate

    void contractModeUpdate(int contractId, ContractMode contractMode) throws Exception
    Throws:
      `Exception`

  - ### contractFaceUpdate

    void contractFaceUpdate(int contractId, ContractFace contractFace) throws Exception
    Throws:
      `Exception`